require 'rubygems'
require 'rspec'
require 'multi_json'
require 'webmock/rspec'
require 'pry'

$LOAD_PATH << 'lib'
require 'git_reflow'

Dir[File.expand_path('../support/**/*.rb', __FILE__)].each {|f| require f}

RSpec.configure do |config|
  config.include GithubHelpers
  config.include WebMock::API
  config.include CommandLineHelpers
  config.include GithubHelpers
  config.include RspecStubHelpers

  config.expect_with :rspec do |c|
    c.syntax = [:should, :expect]
  end

  config.mock_with :rspec do |c|
    c.syntax = [:should, :expect]
  end

  config.before(:each) do
    WebMock.reset!
    stub_command_line
    allow_message_expectations_on_nil
  end

  config.after(:each) do
    WebMock.reset!
    reset_stubbed_command_line
  end
end
